/* Tiny script to create a mandelbrot movie using ARexx ,
   Deluxe Mandelbrot and DPaint...
   (c) 1995 THOR inc. */

/* LF-Character */
lf=x2c('0a')

/* Check if DPaint is available */
if show('p','DPAINT.1') then; do
	address DPAINT.1
	screentofront
	address
	screentofront
	/* Lock GUI */
	lockgui
	requestnotify '"Mandelbrot Movie Generator' || lf || '(c) 1995 THOR inc"'
	requestnotify '"Please select the base' || lf || 'range."'
	offverify
	open
	onverify
	menuselected prefs dragbar 'drag'
	if drag=TRUE then
		menu prefs dragbar
	requestnotify '"Please select the start range !"'
	rangeparms 'start'
	requestrange 'start'
	if start.accept=true then; do
		requestresponse '"O.K. to scale ?"' 'answer'
		if answer=TRUE then
			scale max 'start'

		requestnotify '"Please select the end range !"'
		rangeparms 'end'
		requestrange 'end'
		if end.accept=true then; do
			requestresponse '"O.K. to scale ?"' 'answer'
			if answer=TRUE then
				scale max 'end'
			unlockgui
			requestnumber '"Frames Window"' '"Please enter the number of frames:"' 1 1024 32 'frames'
			lockgui
			frames=frames+0
			if length(frames)>0 then; do
				saveas '"T:Mandel.pic"'
				address
				loadpic '"T:Mandel.pic"' chgtofmt nodither
				setframes frames
				address		
				do i=0 to frames-1
					se=i/(frames-1)
					sb=1-se
					rangeparms 'range'
					range.xmin=sb*start.xmin+se*end.xmin
					range.ymin=sb*start.ymin+se*end.ymin
					range.xmax=sb*start.xmax+se*end.xmax
					range.ymax=sb*start.ymax+se*end.ymax
					setscreenparms 'range'
					unlockgui
					offverify
					menu project start
					waitcomplete
					success 'succ'
					onverify
					lockgui
					if succ='ABORTED' then break
					saveas '"T:Mandel.pic"'
					address
					loadpic '"T:Mandel.pic"'
					nextframe
					address
				end
			end
		end
	end
	requestnotify '"Done !"'
	unlockgui	
	address 
	unlockgui
	address
end; else
	requestnotify '"DPaint is not available !' || lf ||'Please load it first !"'

							

