/*
** $VER: ImageFX_Export_Render 1.0
**
** Copyright  1996 by Simon Edwards
**
** This ARexx script exports the rendered image of the PRIMARY image
** in ImageEngineer to ImageFX. Both programs must be running at the
** same time.
** This script has been tested with ImageFX 1.5 and
** requires ImageEngineer 3.0 (or higher).
**
*/

OPTIONS RESULTS
SIGNAL ON ERROR
TEMP_FILE = 't:Image_from_IE'

if arg()==0 then exit

/* Main code */

IF ~SHOW(PORTS,'IMAGEFX.1') THEN DO
 	'REQUEST' '"Could not locate ImageFxs ARexx port!"' '" OK "'
	CALL ErrorOut 10
END

'RENDER' arg(1)

'SAVE' arg(1) '"'||TEMP_FILE||'"' '"ILBM CmpByteRun1"'
IF (RC ~= 0) THEN DO
 	'REQUEST' '"Error when saving temporary image!"' '" OK "'
	CALL ErrorOut 10
END

'RENDER_CLOSE' arg(1)

ADDRESS "IMAGEFX.1"

Screen2Front

LoadBuffer '"'TEMP_FILE'"' force
IF (RC ~= 0) THEN DO
  ADDRESS 'IMAGEENGINEER'
 	'REQUEST' '"Error when loading temporary image into ImageFX!"' '" OK "'
	CALL ErrorOut 10
END

CALL Errorout 0

/* Errorout procedure */

ErrorOut:
	PARSE ARG ExitCode

	IF (EXISTS( TEMP_FILE )) THEN DO
  	ADDRESS COMMAND "Delete >NIL:" TEMP_FILE
  END
  
	EXIT ExitCode

/* IE's error procedure */

Error:
if RC=5 then do			/* Did the user just cancel us? */
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "'||RESULT||'"'
	exit
end
else do
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "Error detected!!!'||D2C(10)||'Image Engineer error message is as follows'||D2C(10)||result||D2C(10)||'Script failed on line '||SIGL||'"' 'Doh!'
	exit
end
