/*
** $VER: DP5_Import.rexx 1.0 (20/10 1996 Stockholm/Sweden)
** Copyright  1996 by Patrik M Nydensten
**
** This arexx script will import the current image from
** DPaint to ImageEngineer. Both programs must be running
** at the same time.
** This script requires Deluxe Paint 5.0 (or higher)
** and ImageEngineer 3.0 (or higher).
**
*/

Options Results
Signal On Error
temp_file = 't:Image_from_DPaint'

/* Main code */

IF ~SHOW(PORTS,'DPAINT.1') THEN DO
 	'REQUEST' '"Could not locate arexx port DPAINT.1 !"' '" OK "'
	CALL ErrorOut 10
END

address 'DPAINT.1'
 
'SAVEPIC' '"'temp_file'"'
IF (RC ~= 0) THEN DO
  ADDRESS 'IMAGEENGINEER'
 	'REQUEST' '"Failed to save image from DPaint !"' '" OK "'
	CALL ErrorOut 10
END

ADDRESS 'IMAGEENGINEER'

'OPEN' '"'temp_file'"' 'COLOUR'
IF (RC ~= 0) THEN DO
 	'REQUEST' '"Failed to load image into IE!"' '" OK "'
	CALL ErrorOut 10
END
NEW_IMAGE = RESULT

CALL Errorout 0

/* Errorout procedure */

ErrorOut:
	PARSE ARG ExitCode

	IF (EXISTS( TEMP_FILE )) THEN DO
  	ADDRESS COMMAND 'Delete >NIL:' temp_file
  END
  
	EXIT ExitCode

/* IE's error procedure */

Error:
address 'IMAGEENGINEER'
if RC=5 then do			/* Did the user just cancel us? */
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "'||RESULT||'"'
  CALL ErrorOut 10
end
else do
	IE_TO_FRONT
	LAST_ERROR
  'REQUEST "Error detected!!!'||D2C(10)||'Image Engineer error message is as follows'||D2C(10)||result||D2C(10)||'Script failed on line '||SIGL||'"' 'Doh!'
  CALL ErrorOut 10
end
